subroutine output(filename,ix,t,x,Ud,Um,Ue,Ub,Vd,Vv,Vp)
  implicit none
  real(8) :: x(ix)
  real(8) :: Ud(ix), Um(ix,3), Ue(ix)
  real(8) :: Ub(ix,3)
  real(8) :: Vd(ix), Vv(ix,3), Vp(ix)
  real(8) :: u0(ix),ux(ix),uy(ix),uz(ix)
  real(8) :: ex(ix),ey(ix),ez(ix)
  real(8) :: pt(ix)
  real(8) :: t
  integer :: ix, i
  character*256 :: filename      

!  open(16,file=filename,form='unformatted')
  open(16,file=filename)
  write(16,*) '# x(1),ro(2),pr(3),v(4-6),u(7-9),u0(10),',&
       'B(11-13),E(14-16),pr_t(17)'
  do i=1,ix
     u0(i) = 1.d0 / sqrt(1.d0 - (Vv(i,1)**2+Vv(i,2)**2+Vv(i,3)**2))
     ux(i) = u0(i)*Vv(i,1)
     uy(i) = u0(i)*Vv(i,2)
     uz(i) = u0(i)*Vv(i,3)
     ex(i) = Ub(i,2)*Vv(i,3)-Ub(i,3)*Vv(i,2)
     ey(i) = Ub(i,3)*Vv(i,1)-Ub(i,1)*Vv(i,3)
     ez(i) = Ub(i,1)*Vv(i,2)-Ub(i,2)*Vv(i,1)
     pt(i) = Vp(i) + 0.5d0 * ( &
          ( Ub(i,1)**2+Ub(i,2)**2+Ub(i,3)**2 ) * &
          ( 1.d0 - (Vv(i,1)**2+Vv(i,2)**2+Vv(i,3)**2) ) + &
          (Ub(i,1)*Vv(i,1)+Ub(i,2)*Vv(i,2)+Ub(i,3)*Vv(i,3))**2 &
          )
     write(16,999) x(i), Vd(i), Vp(i), Vv(i,1), Vv(i,2), Vv(i,3), &
          ux(i),uy(i),uz(i),u0(i), &
          Ub(i,1),Ub(i,2),Ub(i,3),ex(i),ey(i),ez(i),pt(i)
999  format(17(1x,1p,e12.4e3))
  enddo
  close(16)

  return
end subroutine output
